<?php
namespace Gath\Product;

use Gath\ClientInterface;
use Interop\Container\ContainerInterface;
use Webshop\Product\ProductGatewayInterface;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Class ProductGatewayFactory
 *
 * @package Gath\Product
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/gath-product
 */
final class ProductGatewayFactory implements FactoryInterface
{
    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return ProductGatewayInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $gath = $container->get(ClientInterface::class);
        return new ProductGateway($gath);
    }
}