<?php
namespace GathTest\Product;

use Ak\Test\AbstractTestCase;
use Gath\Product\ConfigProvider;
use Gath\Product\ProductInterface;
use Webshop\Product\ProductGatewayInterface;

final class ProductGatwayTest extends AbstractTestCase
{
    protected $providers = [
        \Ak\Hydrator\ConfigProvider::class,
        \Gath\ConfigProvider::class,
        ConfigProvider::class,
    ];

    protected function getGateway(): ProductGatewayInterface
    {
        $container = $this->getContainer([
            'gath' => [
                'base_uri' => 'http://ak-gath',
            ],
        ]);

        return $container->get(ProductGatewayInterface::class);
    }

    public function testCanGetProductsById()
    {
        $gateway = $this->getGateway();
        /** @var ProductInterface $product */
        $product = $gateway->find(10152251);

        $this->assertInstanceOf(ProductInterface::class, $product);
        $this->assertEquals('PERMIN-Z-5/1', $product->getSku());
        $this->assertEquals('simple', $product->getType());
        $this->assertEquals(10152251, $product->getId());
        $this->assertEquals(152251, $product->getDataLink());
        $this->assertEquals('ALFAPERZ-5/1', $product->getCatalogNumber());
    }
}